/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "Timer.hh"

//======================================  Construct Timer, save the start time.
Timer::Timer(void) {
    clock_gettime(CLOCK_REALTIME, &mStartTime);
}

//======================================  Destroy the timer.
Timer::~Timer(void) {
}

//======================================  Fetch the elapsed time.
Timer::wtime_type
Timer::elapsed(void) const {
    struct timespec now;
    if (clock_gettime(CLOCK_REALTIME, &now) != 0) return -1;
    return double(now.tv_sec  - mStartTime.tv_sec) 
	 + double(now.tv_nsec - mStartTime.tv_nsec) / double(100000000);
}
